%global loongnix_release .6
%global rctag beta3

Name:           luajit
Version:        2.1.0
%global apiver %(v=%{version}; echo ${v%.${v#[0-9].[0-9].}})
%global srcver %{version}%{?rctag:-%{rctag}}
Release:        %{?rctag:%{rctag}}%{loongnix_release}%{?dist}
Summary:        Just-In-Time Compiler for Lua
License:        MIT
URL:            http://luajit.org/
Source0:        http://luajit.org/download/LuaJIT-%{srcver}.tar.gz

# Patches from loongson
Patch0: 0001-basically-support-for-LoongArch-architecture.patch
Patch1: 0002-merge-offical-branch-v2.1.patch
Patch2: 0003-Refactoring-code-in-interpreter-mode.patch
Patch3: 0004-Refactoring-code-in-JIT-mode.patch
Patch4: 0005-Solve-the-remaining-problems.patch
Patch5: 0006-Fix-ffi-calling-conventions.patch
Patch6: 0007-Fix-hidden-bugs-and-merge-offical-branch-v2.1.patch
Patch7: 0008-Fix-segment-fault-and-infinite-loop-when-use-luarock.patch

ExclusiveArch:  x86_64 %{mips} aarch64 s390x ppc64le loongarch64

BuildRequires:  gcc
BuildRequires:  make

%description
LuaJIT implements the full set of language features defined by Lua 5.1.
The virtual machine (VM) is API- and ABI-compatible to the standard
Lua interpreter and can be deployed as a drop-in replacement.

%package devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
This package contains development files for %{name}.

%prep
%autosetup -n LuaJIT-%{srcver} -p1

# Enable Lua 5.2 features
sed -i -e '/-DLUAJIT_ENABLE_LUA52COMPAT/s/^#//' src/Makefile

# preserve timestamps (cicku)
sed -i -e '/install -m/s/-m/-p -m/' Makefile

%build
# Q= - enable verbose output
# E= @: - disable @echo messages
# NOTE: we use amalgamated build as per documentation suggestion doc/install.html
make Q= E=@: PREFIX=%{_prefix} TARGET_STRIP=: \
           CFLAGS="-fwrapv -g" LDFLAGS="%{build_ldflags}" \
           MULTILIB=%{_lib} \
           %{?_smp_mflags}

%install
# PREREL= - disable -betaX suffix
# INSTALL_TNAME - executable name
%make_install PREFIX=%{_prefix} \
              MULTILIB=%{_lib}

rm -rf _tmp_html ; mkdir _tmp_html
cp -a doc _tmp_html/html

# Remove static .a
find %{buildroot} -type f -name *.a -delete -print

# luajit-2.1.0-beta3
pushd %{buildroot}/%{_bindir}
	ln -svf %{name}-%{version}%{?rctag:-%{rctag}} %{name}
popd

%ldconfig_scriptlets

%check

## loongarch64 test failed
%ifnarch loongarch64
make check || true
%endif

%files
%license COPYRIGHT
%doc README
%{_bindir}/%{name}
%{_bindir}/%{name}-%{srcver}
%{_libdir}/lib%{name}-*.so.*
%{_mandir}/man1/%{name}.1*
%{_datadir}/%{name}-%{srcver}/

%files devel
%doc _tmp_html/html/
%{_includedir}/%{name}-%{apiver}/
%{_libdir}/lib%{name}-*.so
%{_libdir}/pkgconfig/%{name}.pc

%changelog
* Wed Aug 31 2022 zhaoxiaolin <zhaoxiaolin@loongson.cn> - 2.1.0-beta3.6
- Fix segment fault and infinite loop when use luarocks

* Mon Jul 11 2022 zhaoxiaolin <zhaoxiaolin@loongson.cn> - 2.1.0-beta3.5
- Fix hidden bugs and merge offical branch v2.1.

* Thu May 19 2022 zhaoxiaolin <zhaoxiaolin@loongson.cn> - 2.1.0-beta3.4
- Solve the remaining problems.
- Fix ffi calling conventions.

* Wed Apr 27 2022 zhaoxiaolin <zhaoxiaolin@loongson.cn> - 2.1.0-beta3.3
- Refactor code.

* Tue Jan 25 2022 zhaoxiaolin <zhaoxiaolin@loongson.cn> - 2.1.0-beta3.2
- Merge offical branch v2.1.

* Thu Dec 9 2021 zhaoxiaolin <zhaoxiaolin@loongson.cn> - 2.1.0-beta3.1
- Add loongarch64 base support.

* Fri Nov 12 2021 zhaoxiaolin <zhaoxiaolin@loongson.cn> - 2.1.0-beta3
- Initial build based on branch v2.1: commit id 75ee3a6159f1831fa57992df3caf5a2c303c281a
